"
COPYRIGHT (c) 2022-2023 LabWare

              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic3' }"

"{ NameSpace: Smalltalk }"

AutomagicSourcePorter subclass:#PharoSourceExporter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Kernel-Classes-Support-Autoporting'
!

!PharoSourceExporter class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2022-2023 LabWare

              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    PharoSourcePorter is a utility class used to automagically
    export (method) code from Smalltalk/X to Pharo.

    [author:]
        Jan Vrany <jan.vrany@labware.com>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!PharoSourceExporter methodsFor:'initialization'!

initializeRewriter
    super initializeRewriter.

    rewriter replace:'Smalltalk isStandAloneApp' with:'"Smalltalk isStandAloneApp"true'.
    rewriter replace:'Smalltalk isSmalltalkX' with:'"Smalltalk isStandAloneApp"false'.
    rewriter replace:'Smalltalk isPharo' with:'"Smalltalk isStandAloneApp"true'.

    rewriter replace: '`@integer printOn: `@stream base: `@base size: `@size fill: `@fill'
                with: '`@stream nextPutAll:(`@integer printPaddedWith: `@fill to: `@size base: `@base)'.

    rewriter replace:'`@class instanceVariableNames' with:'`@class instVarNames'.

    rewriter replace:'`@collection anElement' with:'`@collection anyOne'.
    rewriter replace:'`@collection notEmptyOrNil' with:'`@collection isEmptyOrNil not'.

    rewriter replace:'Dictionary withKeysAndValues:``@pairs' with:'Dictionary newFromPairs: ``@pairs'.
    rewriter replace:'`@bytearray isByteArray' with:'`@bytearray class == ByteArray'.

    rewriter replace:'``@string splitBy:``@delimeter' with:'``@string findTokens: ``@delimeter'.

    rewriter replace:'``@string asSymbolIfInterned' with:'Symbol lookup:``@string'.

    rewriter replace:'OperatingSystem isUNIXlike' with: 'Smalltalk os isUnix'.
    rewriter replace:'OperatingSystem isMSWINDOWSlike' with: 'Smalltalk os isWindows'.

    rewriter replace:'`@r asFilename' with: '`@r asFileReference'.

    "Created: / 21-09-2022 / 12:34:59 / Jan Vrany <jan.vrany@labware.com>"
    "Modified: / 25-07-2023 / 11:38:17 / Jan Vrany <jan.vrany@labware.com>"
! !

!PharoSourceExporter class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

